// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from robot_controllers_msgs:msg/DiffDriveLimiterParams.idl
// generated code does not contain a copyright notice
#include "robot_controllers_msgs/msg/detail/diff_drive_limiter_params__rosidl_typesupport_fastrtps_cpp.hpp"
#include "robot_controllers_msgs/msg/detail/diff_drive_limiter_params__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace robot_controllers_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_serialize(
  const robot_controllers_msgs::msg::DiffDriveLimiterParams & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: max_linear_velocity
  cdr << ros_message.max_linear_velocity;
  // Member: max_linear_acceleration
  cdr << ros_message.max_linear_acceleration;
  // Member: max_angular_velocity
  cdr << ros_message.max_angular_velocity;
  // Member: max_angular_acceleration
  cdr << ros_message.max_angular_acceleration;
  // Member: max_wheel_velocity
  cdr << ros_message.max_wheel_velocity;
  // Member: track_width
  cdr << ros_message.track_width;
  // Member: angular_velocity_limits_linear_velocity
  cdr << (ros_message.angular_velocity_limits_linear_velocity ? true : false);
  // Member: scale_to_wheel_velocity_limits
  cdr << (ros_message.scale_to_wheel_velocity_limits ? true : false);
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  robot_controllers_msgs::msg::DiffDriveLimiterParams & ros_message)
{
  // Member: max_linear_velocity
  cdr >> ros_message.max_linear_velocity;

  // Member: max_linear_acceleration
  cdr >> ros_message.max_linear_acceleration;

  // Member: max_angular_velocity
  cdr >> ros_message.max_angular_velocity;

  // Member: max_angular_acceleration
  cdr >> ros_message.max_angular_acceleration;

  // Member: max_wheel_velocity
  cdr >> ros_message.max_wheel_velocity;

  // Member: track_width
  cdr >> ros_message.track_width;

  // Member: angular_velocity_limits_linear_velocity
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.angular_velocity_limits_linear_velocity = tmp ? true : false;
  }

  // Member: scale_to_wheel_velocity_limits
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.scale_to_wheel_velocity_limits = tmp ? true : false;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
get_serialized_size(
  const robot_controllers_msgs::msg::DiffDriveLimiterParams & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: max_linear_velocity
  {
    size_t item_size = sizeof(ros_message.max_linear_velocity);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: max_linear_acceleration
  {
    size_t item_size = sizeof(ros_message.max_linear_acceleration);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: max_angular_velocity
  {
    size_t item_size = sizeof(ros_message.max_angular_velocity);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: max_angular_acceleration
  {
    size_t item_size = sizeof(ros_message.max_angular_acceleration);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: max_wheel_velocity
  {
    size_t item_size = sizeof(ros_message.max_wheel_velocity);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: track_width
  {
    size_t item_size = sizeof(ros_message.track_width);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: angular_velocity_limits_linear_velocity
  {
    size_t item_size = sizeof(ros_message.angular_velocity_limits_linear_velocity);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: scale_to_wheel_velocity_limits
  {
    size_t item_size = sizeof(ros_message.scale_to_wheel_velocity_limits);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
max_serialized_size_DiffDriveLimiterParams(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: max_linear_velocity
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: max_linear_acceleration
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: max_angular_velocity
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: max_angular_acceleration
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: max_wheel_velocity
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: track_width
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: angular_velocity_limits_linear_velocity
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: scale_to_wheel_velocity_limits
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = robot_controllers_msgs::msg::DiffDriveLimiterParams;
    is_plain =
      (
      offsetof(DataType, scale_to_wheel_velocity_limits) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _DiffDriveLimiterParams__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::msg::DiffDriveLimiterParams *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _DiffDriveLimiterParams__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<robot_controllers_msgs::msg::DiffDriveLimiterParams *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _DiffDriveLimiterParams__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::msg::DiffDriveLimiterParams *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _DiffDriveLimiterParams__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_DiffDriveLimiterParams(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _DiffDriveLimiterParams__callbacks = {
  "robot_controllers_msgs::msg",
  "DiffDriveLimiterParams",
  _DiffDriveLimiterParams__cdr_serialize,
  _DiffDriveLimiterParams__cdr_deserialize,
  _DiffDriveLimiterParams__get_serialized_size,
  _DiffDriveLimiterParams__max_serialized_size
};

static rosidl_message_type_support_t _DiffDriveLimiterParams__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_DiffDriveLimiterParams__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace robot_controllers_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_robot_controllers_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<robot_controllers_msgs::msg::DiffDriveLimiterParams>()
{
  return &robot_controllers_msgs::msg::typesupport_fastrtps_cpp::_DiffDriveLimiterParams__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, msg, DiffDriveLimiterParams)() {
  return &robot_controllers_msgs::msg::typesupport_fastrtps_cpp::_DiffDriveLimiterParams__handle;
}

#ifdef __cplusplus
}
#endif
