// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from robot_controllers_msgs:srv/QueryControllerStates.idl
// generated code does not contain a copyright notice
#include "robot_controllers_msgs/srv/detail/query_controller_states__rosidl_typesupport_fastrtps_cpp.hpp"
#include "robot_controllers_msgs/srv/detail/query_controller_states__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace robot_controllers_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const robot_controllers_msgs::msg::ControllerState &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  robot_controllers_msgs::msg::ControllerState &);
size_t get_serialized_size(
  const robot_controllers_msgs::msg::ControllerState &,
  size_t current_alignment);
size_t
max_serialized_size_ControllerState(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace robot_controllers_msgs


namespace robot_controllers_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_serialize(
  const robot_controllers_msgs::srv::QueryControllerStates_Request & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: updates
  {
    size_t size = ros_message.updates.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      robot_controllers_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.updates[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  robot_controllers_msgs::srv::QueryControllerStates_Request & ros_message)
{
  // Member: updates
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.updates.resize(size);
    for (size_t i = 0; i < size; i++) {
      robot_controllers_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.updates[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
get_serialized_size(
  const robot_controllers_msgs::srv::QueryControllerStates_Request & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: updates
  {
    size_t array_size = ros_message.updates.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        robot_controllers_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.updates[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
max_serialized_size_QueryControllerStates_Request(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: updates
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        robot_controllers_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_ControllerState(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = robot_controllers_msgs::srv::QueryControllerStates_Request;
    is_plain =
      (
      offsetof(DataType, updates) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _QueryControllerStates_Request__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::srv::QueryControllerStates_Request *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _QueryControllerStates_Request__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<robot_controllers_msgs::srv::QueryControllerStates_Request *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _QueryControllerStates_Request__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::srv::QueryControllerStates_Request *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _QueryControllerStates_Request__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_QueryControllerStates_Request(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _QueryControllerStates_Request__callbacks = {
  "robot_controllers_msgs::srv",
  "QueryControllerStates_Request",
  _QueryControllerStates_Request__cdr_serialize,
  _QueryControllerStates_Request__cdr_deserialize,
  _QueryControllerStates_Request__get_serialized_size,
  _QueryControllerStates_Request__max_serialized_size
};

static rosidl_message_type_support_t _QueryControllerStates_Request__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_QueryControllerStates_Request__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace robot_controllers_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_robot_controllers_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<robot_controllers_msgs::srv::QueryControllerStates_Request>()
{
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates_Request__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, srv, QueryControllerStates_Request)() {
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates_Request__handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include <limits>
// already included above
// #include <stdexcept>
// already included above
// #include <string>
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
// already included above
// #include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
// functions for robot_controllers_msgs::msg::ControllerState already declared above


namespace robot_controllers_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_serialize(
  const robot_controllers_msgs::srv::QueryControllerStates_Response & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: state
  {
    size_t size = ros_message.state.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      robot_controllers_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.state[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  robot_controllers_msgs::srv::QueryControllerStates_Response & ros_message)
{
  // Member: state
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.state.resize(size);
    for (size_t i = 0; i < size; i++) {
      robot_controllers_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.state[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
get_serialized_size(
  const robot_controllers_msgs::srv::QueryControllerStates_Response & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: state
  {
    size_t array_size = ros_message.state.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        robot_controllers_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.state[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_robot_controllers_msgs
max_serialized_size_QueryControllerStates_Response(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: state
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size =
        robot_controllers_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_ControllerState(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = robot_controllers_msgs::srv::QueryControllerStates_Response;
    is_plain =
      (
      offsetof(DataType, state) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _QueryControllerStates_Response__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::srv::QueryControllerStates_Response *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _QueryControllerStates_Response__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<robot_controllers_msgs::srv::QueryControllerStates_Response *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _QueryControllerStates_Response__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const robot_controllers_msgs::srv::QueryControllerStates_Response *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _QueryControllerStates_Response__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_QueryControllerStates_Response(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _QueryControllerStates_Response__callbacks = {
  "robot_controllers_msgs::srv",
  "QueryControllerStates_Response",
  _QueryControllerStates_Response__cdr_serialize,
  _QueryControllerStates_Response__cdr_deserialize,
  _QueryControllerStates_Response__get_serialized_size,
  _QueryControllerStates_Response__max_serialized_size
};

static rosidl_message_type_support_t _QueryControllerStates_Response__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_QueryControllerStates_Response__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace robot_controllers_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_robot_controllers_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<robot_controllers_msgs::srv::QueryControllerStates_Response>()
{
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates_Response__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, srv, QueryControllerStates_Response)() {
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates_Response__handle;
}

#ifdef __cplusplus
}
#endif

#include "rmw/error_handling.h"
// already included above
// #include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/service_type_support_decl.hpp"

namespace robot_controllers_msgs
{

namespace srv
{

namespace typesupport_fastrtps_cpp
{

static service_type_support_callbacks_t _QueryControllerStates__callbacks = {
  "robot_controllers_msgs::srv",
  "QueryControllerStates",
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, srv, QueryControllerStates_Request)(),
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, srv, QueryControllerStates_Response)(),
};

static rosidl_service_type_support_t _QueryControllerStates__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_QueryControllerStates__callbacks,
  get_service_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace srv

}  // namespace robot_controllers_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_robot_controllers_msgs
const rosidl_service_type_support_t *
get_service_type_support_handle<robot_controllers_msgs::srv::QueryControllerStates>()
{
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, robot_controllers_msgs, srv, QueryControllerStates)() {
  return &robot_controllers_msgs::srv::typesupport_fastrtps_cpp::_QueryControllerStates__handle;
}

#ifdef __cplusplus
}
#endif
